﻿package
{
    import flash.text.*;
    
    import flash.events.*;
    import fl.events.SliderEvent;
    import flash.display.*;
    import flash.filters.*;
    
    import flash.ui.Keyboard;
    import flash.utils.Timer;
    
    import de.polygonal.ds.*;
    
    import org.papervision3d.cameras.*;
    import org.papervision3d.events.*;
    import org.papervision3d.materials.*;
    import org.papervision3d.objects.*;
    import org.papervision3d.scenes.*;
    import org.papervision3d.core.proto.extra.*;
    import org.papervision3d.components.as3.utils.ObjectController;

    //import org.papervision3d.core.proto.*;

    
    public class Main extends Sprite {
        // Scene stuff
        private var container:Sprite;
        private var scene:Scene3D;
        private var camera:Camera3D;
        private var rootNode:DisplayObject3D;

/*        private var viewXY:Viewport;
        private var viewXZ:Viewport;
        private var viewZY:Viewport;
*/
        private var coneList:Array;
        private var cylinderList:Array;

        // Slice stuff
        private var graph:Graph;
        private var grid:Array2;
        private var nodeCanvas:Sprite;
        public static var MyriadProFont:Font = new MyriadPro();
        public static const k_nodeRadius:int  = 10;
        public static const k_nodeHeight:int  = 36; // 0.34*21*radius/2
        public static const k_gridWidth:int   = 16;
        public static const k_gridHeight:int  = 8;
        public static const k_gridSpacing:int = k_nodeRadius * 2;

        // Camera stuff
        var targetTravel:Boolean;
        public static const camera_x_offset:int  = 150;
        public static const camera_y_offset:int  = 110;

        //var light  :Light3D;

        public function Main() {
            //configureListeners();
            trace(k_nodeHeight);
            stage.quality = "HIGH";
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;
            //stage.addEventListener(Event.RESIZE, onResize);
            
            // 3D stuff
            coneList = new Array();
            cylinderList = new Array();
            
            // Creates scene
            container = new Sprite();
            container.x = 150; //340/2; //Math.round(stage.stageWidth/2);
            container.y = 0; //600/2; //Math.round(stage.stageHeight/2);
            trace(renderPanel.height);
            renderPanel.addChild(container);
            scene = new Scene3D(container);
            rootNode = new DisplayObject3D("rootNode");
            scene.addChild(rootNode);
            
            // Creates cameras
            camera = new Camera3D();
            camera.x = camera_x_offset;
            camera.z = -500;
            camera.y = camera_x_offset;
            camera.zoom = 5;
            camera.focus = 200;
            //targetTravel = true;
            camera.target.x = camera_x_offset;
            camera.target.y = camera_x_offset;
            camera.target.z = 18;
            // Adds objects to 3D scene
            //addCone(0, 0, 0);
            //addCylinder(0, 0, 0);
            addEventListener(Event.ENTER_FRAME, tick);
            
            // Creates 2D slice grid
            grid = new Array2(k_gridWidth, k_gridHeight);
            graph = new Graph(grid.size);
            Node.RADIUS = k_nodeRadius;
            slicePanel.addChild(nodeCanvas = new Sprite());
            nodeCanvas.x = nodeCanvas.y = k_nodeRadius * 2;
            
            //create rectangular array of nodes
            var i:int = 0;
            var node:Node;
            for (var y:int = 0; y < grid.height; y++)
            {
                for (var x:int = 0; x < grid.width; x++)
                {
                    node = new Node(i);
                    nodeCanvas.addChild(node);
                    
                    if ((x % 2) ^ (y % 2)) {
                        node.y = y*k_nodeRadius*3*1.05 + k_nodeRadius;
                    } else {
                        node.y = y*k_nodeRadius*3*1.05;
                    }
                    node.x = x*k_nodeRadius*1.7320*1.1
                    
                    var tf:TextField = node.getChildAt(0) as TextField;
                    var tfm:TextFormat = tf.getTextFormat();
                    tfm.size = 14;
                    tf.defaultTextFormat = tfm;
                    
                    graph.addNode(node, i);
                    
                    grid.set(x, y, node);
                    i++;
                    
                    node.addEventListener(MouseEvent.MOUSE_MOVE, onMove, false, 1000);
                    node.addEventListener(MouseEvent.MOUSE_OUT,  onMouseOut, false, 1000);
                    node.addEventListener(MouseEvent.CLICK, onClick, false, 1000);
                }
            }
            
            
        }
        
        private function addCone(p_x:Number, p_y:Number, p_z:Number):void {
            // Adds a cone to the entire scene
            var coneIndex:uint = coneList.length;
            var newConeMaterial:BitmapAssetMaterial = new BitmapAssetMaterial(coneIndex % 2 == 1 ? "ConeDiffuseYellow" : "ConeDiffuseBlack");
            var newCone:Ase = new Ase(newConeMaterial, "cone.ase", 0.1);
            rootNode.addChild(newCone);
            coneList[coneIndex] = newCone;
            newCone.x = p_x;
            newCone.y = p_y;
            newCone.z = p_z;
        }
        
        private function addCylinder(p_x:Number, p_y:Number, p_z:Number):void {
            // Adds a cylinder to the entire scene
            var cylinderIndex:uint = cylinderList.length;
            //var newCylinderMaterial:WireframeMaterial = new WireframeMaterial(0x000000);
            var newCylinderMaterial:ColorMaterial = new ColorMaterial(0x03a3f0);
            var newCylinder:Cylinder = new Cylinder(newCylinderMaterial, k_nodeRadius+2, k_nodeHeight, 10, 6, 0, null);
            newCylinder.rotationX = 90;
            rootNode.addChild(newCylinder);
            cylinderList[cylinderIndex] = newCylinder;
            newCylinder.x = p_x;
            newCylinder.y = p_y;
            newCylinder.z = p_z;
        }
        
        var angle:Number = 0;
        
        private function tick(event:Event):void {
            // A tick of the engine
            camera.x = Math.cos(angle)*750 + camera_x_offset
            camera.z = Math.sin(angle)*750
            angle+=0.05
              
            //scene.renderCamera(camera, light);
            scene.renderCamera(camera);
        }
        
        
        
        private function configureListeners():void {
            basePanel.zoomslider.addEventListener(SliderEvent.CHANGE, sliderChanged);
            basePanel.zoomslider.addEventListener(SliderEvent.THUMB_RELEASE, sliderRelease);
            basePanel.focusslider.addEventListener(SliderEvent.CHANGE, focussliderChanged);
            basePanel.focusslider.addEventListener(SliderEvent.THUMB_RELEASE, foucssliderRelease);

        }
        
        private function sliderRelease(e:SliderEvent):void {
            camera.zoom = e.target.value;
        }
        
        private function sliderChanged(e:SliderEvent):void {
            basePanel.zoomsliderLabel.text =  e.target.value;
        }
        private function foucssliderRelease(e:SliderEvent):void {
            camera.focus = e.target.value;
        }
        
        private function focussliderChanged(e:SliderEvent):void {
            basePanel.focussliderLabel.text =  e.target.value;
        }


        private function onClick(e:MouseEvent):void
        {
            // check if target is marked
            if (e.target.marked) {
                // check if pairedNeighbor is marked
                if (e.target.pairedNeighbor.marked) {
                    // unmark and unpair both
                    e.target.pairedNeighbor.unmark();
                    e.target.unmark();
                    e.target.neighbor.pairedNeighbor = null;
                    e.target.pairedNeighbor = null;
                }
            } else if (!e.target.marked) { // target is unmarked
                if (e.target.neighbor == null) {
                    return; // return if no neighbors
                }
                if (!e.target.neighbor.marked) { // if neighbor is unmarked
                    // mark and pair both
                    e.target.pairedNeighbor = e.target.neighbor;
                    e.target.neighbor.pairedNeighbor = e.target;
                    e.target.neighbor.mark();
                    e.target.mark();
                    addCylinder(e.target.x, -e.target.y, 0);
                    addCylinder(e.target.neighbor.x, -e.target.neighbor.y, 0);
                    //camera.target.x = e.target.x;
                    //camera.target.y = e.target.y;
                }
            } 
        }
        
        private function getDist(x1:int,x2:int,y1:int,y2:int):int {
            return Math.sqrt(Math.pow(x1-x2,2)+Math.pow(y1-y2,2));
        }
        
        private function onMouseOut(e:MouseEvent):void
        {
            var rowcol:Array = [];
            var neighbors:Array = new Array();
            var row:int;
            var col:int;
            var odd:int;
            
            rowcol = grid.rowcolIndex(e.target); // get (x,y) coords of node
            row = rowcol[0];
            col = rowcol[1];
            odd = (row % 2) ^ (col % 2); // get parity
            // get row + 1 if valid
            if (row < k_gridWidth-1) {
                neighbors.push(grid.get(row+1,col));
            }
            
            // get row - 1 if valid
            if (row > 0) {
                neighbors.push(grid.get(row-1,col));
            }
            
            if (odd == 1) { // get col + 1 if valid
                if (col < k_gridHeight-1) {
                    neighbors.push(grid.get(row,col+1));
                }
            } else { // get col+1 if valid
                if (col > 0) {
                    neighbors.push(grid.get(row,col-1));
                }
            }
            var i:int;
            for (i = 0; i < neighbors.length; i++)
            {
                neighbors[i].unhover()
            }
            e.target.unhover();
        }
        
        private function onMove(e:MouseEvent):void
        {
            var x:int = e.target.x;
            var y:int = e.target.y;
            var rowcol:Array = [];
            var row:int;
            var col:int;
            var odd:int;
            var dist:int;
            var minDist:int = 9999;
            var neighbor:Node;
            var pairedNeighbor:Node;
            var nearestNeighbor:Node;
            var neighbors:Array = new Array();
            var nearestNeighborIndex:int;
            var info:String = "";
            
            rowcol = grid.rowcolIndex(e.target); // get (x,y) coords of node
            row = rowcol[0];
            col = rowcol[1];
            odd = (row % 2) ^ (col % 2); // get parity
            
            info += "mouse:" + e.stageX + "," + e.stageY + "\n";
            info += "node " + e.target.graphIndex + ": " + x + "," + y + "\n";
            info += "marked: " + e.target.marked + "\n";
            info += "neighbor: " + e.target.neighbor +  "\n";
            if (e.target.pairedNeighbor != null) {
                pairedNeighbor = e.target.pairedNeighbor;
                e.target.pairedhover();
                pairedNeighbor.pairedhover();
                basePanel.sliceText.text = info;
                return;
            }
            
            // get row + 1 if valid
            if (row < k_gridWidth-1) {
                neighbor = grid.get(row+1,col)
                neighbors.push(neighbor);
            }
            
            // get row - 1 if valid
            if (row > 0) {
                neighbor = grid.get(row-1,col)
                neighbors.push(neighbor);
            }
            
            if (odd == 1) { // get col + 1 if valid
                if (col < k_gridHeight-1) {
                    neighbor = grid.get(row,col+1)
                    neighbors.push(neighbor);
                }
            } else { // get col+1 if valid
                if (col > 0) {
                    neighbor = grid.get(row,col-1)
                    neighbors.push(neighbor);
                }
            }
            
            var i:int;
            if (neighbors.length > 0) {
                for (i = 0; i < neighbors.length; i++) {
                    dist = getDist(e.stageX,neighbors[i].x+20,
                                   e.stageY,neighbors[i].y+20);
                    info += "[" + neighbors[i].graphIndex + ":" +
                            dist + "] ";
                    if (neighbors[i].pairedNeighbor != null) {
                        continue;
                    }
                    if (dist < minDist) {
                        minDist = dist;
                        nearestNeighborIndex = i;
                    }
                }
                
                nearestNeighbor = neighbors[nearestNeighborIndex]
                if (nearestNeighbor == pairedNeighbor) {
                    nearestNeighbor.pairedhover();
                    neighbors.splice(nearestNeighborIndex,1);
                } else if (nearestNeighbor.pairedNeighbor != null) {
                    return;
                } else {
                    nearestNeighbor.hover();
                    e.target.neighbor = nearestNeighbor;
                    e.target.neighbor.neighbor = e.target;
                    neighbors.splice(nearestNeighborIndex,1);
                }
                
                for (i = 0; i < neighbors.length; i++)
                {
                    neighbors[i].unhover();
                }
            }
            
            basePanel.sliceText.text = info;
        }
    }
    
}