package
{
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    
    public class Node extends Sprite
    {
        // class variables
        public static var RADIUS:int = 5;
        public static var BORDER_CLR_MARK:int     = 0xf40095;
        public static var BORDER_CLR_UNMARK:int   = 0x999999;
        public static var BORDER_CLR_ROLLOVER:int = 0x03a3f0;
        public static var BORDER_CLR_PAIRED:int   = 0xf7931e; // 0xfe9ad7;

        public static var FILL_CLR:int            = 0xffffff;
        public static var waypoint:int = 0;
        
        // instance variables
        public var graphIndex:int;
        public var marked:Boolean;
        public var enabled:Boolean;
        public var wp:int = -1;
        public var neighbor:* = null; // most recent close neighbor
        public var pairedNeighbor:* = null; // clicked pair
        
        public function Node(graphIndex:int)
        {
            //trace("new node:" + graphIndex)
            drawNode(BORDER_CLR_UNMARK);
            drawText();
            write("");
            //write(graphIndex.toString());
            marked = false;
            this.graphIndex = graphIndex;
            enabled = true;
            doubleClickEnabled = true;
            mouseChildren = false;
            freeze(false);
        }
        
        public function freeze(flag:Boolean):void
        {
            if (flag)
            {
                //removeEventListener(MouseEvent.DOUBLE_CLICK, onNodeDoubleClick);
                removeEventListener(MouseEvent.MOUSE_OVER, onRollOver);
                removeEventListener(MouseEvent.MOUSE_OUT,  onRollOut);
            }
            else
            {
                //addEventListener(MouseEvent.DOUBLE_CLICK, onNodeDoubleClick, false, 2000);
                addEventListener(MouseEvent.MOUSE_OVER, onRollOver, false, 1000);
                addEventListener(MouseEvent.MOUSE_OUT,  onRollOut, false, 1000);
                //addEventListener(MouseEvent.CLICK, onPress, false, 1000);
            }
        }
        
        public function mark():void
        {
            marked = true;
            drawNode(BORDER_CLR_MARK);
        }
        
        public function unmark():void
        {
            marked = false;
            drawNode(BORDER_CLR_UNMARK);
        }
        
        public function pairedhover():void
        {
            drawNode(BORDER_CLR_PAIRED);
        }
        
        public function hover():void
        {
            if (marked) return;
            drawNode(BORDER_CLR_ROLLOVER);
        }
        
        public function unhover():void
        {
            if (marked) {
                drawNode(BORDER_CLR_MARK);
            } else {
                drawNode(BORDER_CLR_UNMARK);
            }
        }
        
        public function write(s:String):void
        {
            var tf:TextField = getChildAt(0) as TextField;
            tf.text = s;
            tf.x = int(-tf.width  / 2);
            tf.y = int(-tf.height / 2);
        }
        
        private function onRollOver(e:MouseEvent):void
        {
            if (marked) return;
            drawNode(BORDER_CLR_ROLLOVER);
        }
        
        private function onRollOut(e:MouseEvent):void
        {
            if (marked) return;
            drawNode(BORDER_CLR_UNMARK);
        }
        
        private function onNodeClick(e:MouseEvent):void
        {
            trace(e + "marked"+ marked);
            marked = !marked;
            drawNode(marked ? BORDER_CLR_MARK : BORDER_CLR_ROLLOVER);
        }
        
        private function drawNode(clr:uint):void
        {
            graphics.clear();
            graphics.beginFill(FILL_CLR, 1);
            graphics.lineStyle(2, clr, 1);
            graphics.drawCircle(0, 0, RADIUS);
            graphics.endFill();
        }
        
        private function drawText():void
        {
            var tf:TextField = new TextField();
            tf.name = "counter";
            tf.defaultTextFormat = new TextFormat(Main.MyriadProFont.fontName, 11, 0, false, false, null, null, null, "center");
            tf.embedFonts = true;
            tf.antiAliasType = "advanced";
            tf.selectable = false;
            tf.autoSize = "left";
            addChild(tf);
        }
        
        override public function toString():String
        {
            return "[NODE, graphIndex " + graphIndex + "]";
        }
    }
}
