package org.papervision3d.core.proto
{
    import org.papervision3d.core.geom.*;

    public class OldFindHitCallback extends OldTraverseCallback
    {
        public var object:Object3D = null;
        public var tri:DrawTriangle = null;
        public var path:Array = null;

        private var curpath:Array = new Array();
        private var x:Number;
        private var y:Number;

        public var distance:Number;

        public function OldFindHitCallback(x:Number, y:Number, mindistance:Number = Infinity)
        {   
            this.x = x;
            this.y = y;
            this.distance = mindistance;
        }

        public override function triangle(triangle:DrawTriangle, object:Object3D):void
        {
            if (distance == 0)
                if (tri != null)
                    if (triangle.screenZ > tri.screenZ)
                        return;

            if (triangle.inside(x, y))
            {
                distance = 0;
                found(triangle, object);
                return;
            }

            if (distance == 0)
                return;

            var newdist:Number = triangle.distanceToCenter(x, y);
            if (newdist < distance)
            {
                distance = newdist;
                found(triangle, object);
            }
        }

        protected function found(triangle:DrawTriangle, object:Object3D):void
        {
            this.tri = triangle;
            this.object = object;
            this.path = (new Array()).concat(curpath);
        }
    }
}
